## dogtag-pki 11.0.0

=== themes/CMakeLists.txt ===
project(themes)

add_subdirectory(${THEME})
