=== themes/dogtag/CMakeLists.txt ===
project(dogtag)

# compute certificate system name
set(CERTIFICATE_SYSTEM_THEME "Dogtag")
if ("${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}" STREQUAL "10.5")
    set(CERTIFICATE_SYSTEM_VERSION "9")
elseif ("${APPLICATION_VERSION_MAJOR}.${APPLICATION_VERSION_MINOR}" STREQUAL "10.6")
    set(CERTIFICATE_SYSTEM_VERSION "10")
else()
    set(CERTIFICATE_SYSTEM_VERSION "")
endif()
set(CERTIFICATE_SYSTEM_NAME "${CERTIFICATE_SYSTEM_THEME} Certificate System ${CERTIFICATE_SYSTEM_VERSION}")

add_subdirectory(common-ui)

if (BUILD_PKI_CONSOLE)
    add_subdirectory(console-ui)
endif (BUILD_PKI_CONSOLE)
