=== debian/changelog ===
dogtag-pki (11.0.0-1) unstable; urgency=medium

  * New upstream release
    - CVE-2020-25715 (Closes: #988153)
  * dont-install-deleted-files.diff: Dropped, obsolete.
  * patches: Refreshed.
  * rules: Bump tomcat source path.
  * add-freebl-headers.diff: Add headers that libnss3-dev doesn't ship.
  * pki-tools: Add p12tool.
  * tests: Add --debug to pkispawn/pkidestroy.
  * Update service files.
  * control: Drop python3-pytest-runner from build-deps, not used anymore.
  * use-resteasy-legacy.diff: Dropped, obsolete and not applied anyway.
  * control: Drop unused libcommons-collections3-java from server depends.
  * fix-tomcat-paths.diff: Add catalina.properties and pki.policy to list of files to fix.
  * fix-symkey-path.diff: Refreshed.
  * control: Bump depends on libjss-java, libldap-java, libtomcatjss-java, libidm-console-framework-java.
  * install: Fix javadoc install.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 19 Oct 2021 18:25:25 +0300

dogtag-pki (10.10.6-1) unstable; urgency=medium

  * New upstream release. (Closes: #993534)
    - CVE-2021-3551 (Closes: #991665)
  * CVE-2021-20179.diff: Dropped, upstream.
  * Refresh patches.
  * JNA requirement got dropped, update packaging for it.
  * pki-server.postinst: Remove world access from existing installation
    logs.
  * control: Drop velocity from depends, it's not used anymore.
  * control: Drop libcommons-httpclient-java from depends, not used
    anymore.
  * control: Bump libjss dependency.
  * pki-tps.install: Updated.
  * tests: Add iproute2 to test depends. (Closes: #991173)
  * tests: Add isolation-container to test restrictions. (Closes:
    #991174)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 07 Sep 2021 14:25:32 +0300
