=== debian/watch ===
version=4
opts="compression=xz,repack,uversionmangle=s/-/~/, \
  filenamemangle=s%(?:.*?)?v@ANY_VERSION@\.tar\.gz%dogtag-pki-$1.tar.xz%" \
  https://github.com/dogtagpki/pki/releases/ \
  (?:.*?/)?v@ANY_VERSION@\.tar\.gz
